Namespace My

    ' The following events are availble for MyApplication:
    ' 
    ' Startup: Raised when the application starts, before the startup form is created.
    ' Shutdown: Raised after all application forms are closed.  This event is not raised if the application terminates abnormally.
    ' UnhandledException: Raised if the application encounters an unhandled exception.
    ' StartupNextInstance: Raised when launching a single-instance application and the application is already active. 
    ' NetworkAvailabilityChanged: Raised when the network connection is connected or disconnected.
    Partial Friend Class MyApplication

        Private Sub MyApplication_Shutdown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shutdown
            My.Computer.FileSystem.DeleteDirectory(My.Settings.mdirectory & "\cprojects\tempfiles", FileIO.DeleteDirectoryOption.DeleteAllContents)
        End Sub

        Private Sub MyApplication_Startup(ByVal sender As Object, ByVal e As Microsoft.VisualBasic.ApplicationServices.StartupEventArgs) Handles Me.Startup


            'Gets directory
            My.Settings.mdirectory = My.Computer.FileSystem.CurrentDirectory.ToString()

            'checks if main files exist
            If My.Settings.open1 = True Then
                My.Settings.open1 = False
                My.Computer.FileSystem.CopyFile(My.Settings.mdirectory & "\views\rtags.txt", My.Settings.mdirectory & "\views\utags.xml", True)
                My.Computer.FileSystem.CopyFile(My.Settings.mdirectory & "\views\hlpr.txt", My.Settings.mdirectory & "\views\hlpr.xml", True)
            End If

            'license
            If My.Settings.firstopen = True Then
                license.Show()
            End If

        End Sub

        Private Sub MyApplication_UnhandledException(ByVal sender As Object, ByVal e As Microsoft.VisualBasic.ApplicationServices.UnhandledExceptionEventArgs) Handles Me.UnhandledException
            MsgBox("There was an unhandled ERROR in the application! I recommend restarting the program.", , "AAAAAAHHHH!!")
        End Sub
    End Class

End Namespace

