Imports System
Imports System.IO
Imports System.Xml
Imports Microsoft.VisualBasic.Strings
Imports HTML_Editor.My

Public Class extensions

    Public Shared stream As StreamReader
    Public Shared xwriter As XmlTextWriter

    Public Shared Sub write(ByVal extensionname As String, ByVal viewinbrowser As Boolean, ByVal write As Boolean, ByVal disptxt As String, Optional ByVal icon As String = "default", Optional ByVal browserdispfileonviewinbrowserfalse As String = "usrnodisp.htm", Optional ByVal writeto As String = "maindir", Optional ByVal useoldvalueonovrwrite As Boolean = False)
        Dim mdir As String
        ' Gets main directory

        If writeto = "maindir" Then
            mdir = Settings.mdirectory & "\views\utags.xml"
        Else
            mdir = writeto
        End If
        'Checks if file exists
        If My.Computer.FileSystem.FileExists(mdir) = False Then
            MsgBox("The file " & mdir & " was not found. Please reload the program")
        Else
            Try
                'dim all variables
                Dim tagamt As New Single
                Dim name(99999) As String
                Dim view(99999) As Boolean
                Dim edit(99999) As Boolean
                Dim disp(99999) As String
                Dim imgdisp(99999) As String
                Dim errdisp(99999) As String

                'gets the previous contents of the file
                Dim sr As New System.IO.StreamReader(mdir)
                Dim xr As New System.Xml.XmlTextReader(sr)
                Dim doc As New System.Xml.XmlDocument
                doc.Load(xr)
                Dim xmlr As System.Xml.XmlNodeList = doc.SelectNodes("tags/script")
                Dim ver As Integer = xmlr.Item(0).FirstChild.InnerText
                If ver <> 1 Then
                    MsgBox("The versions of the file " & mdir & " do not comply with the reader. The file cannot be read")
                Else
                    tagamt = xmlr.Item(0).FirstChild.NextSibling.InnerText
                    xmlr = doc.SelectNodes("tags/tag")
                    Dim itemamt As Single = 0
                    Do Until tagamt = itemamt
                        name(itemamt) = xmlr.Item(itemamt).FirstChild.InnerText
                        view(itemamt) = xmlr.Item(itemamt).FirstChild.NextSibling.InnerText
                        edit(itemamt) = xmlr.Item(itemamt).FirstChild.NextSibling.NextSibling.InnerText
                        disp(itemamt) = xmlr.Item(itemamt).FirstChild.NextSibling.NextSibling.NextSibling.InnerText
                        imgdisp(itemamt) = xmlr.Item(itemamt).FirstChild.NextSibling.NextSibling.NextSibling.NextSibling.InnerText
                        If view(itemamt) = False Then
                            errdisp(itemamt) = xmlr.Item(itemamt).FirstChild.NextSibling.NextSibling.NextSibling.NextSibling.NextSibling.InnerText
                        End If
                        itemamt = itemamt + 1
                    Loop
                    sr.Close()

                    'Deletes the previous file
                    My.Computer.FileSystem.DeleteFile(mdir)

                    'Gets data ready for new writing
                    Dim g As Single = 0
                    Dim found As Boolean = False
                    Do Until g = itemamt Or found = True
                        If name(g) = extensionname Then
                            found = True
                        End If
                        g = g + 1
                    Loop
                    If found = True Then
                        g = g - 1
                        view(g) = viewinbrowser
                        edit(g) = write
                        disp(g) = disptxt
                        If icon <> "default" Then
                            imgdisp(g) = icon
                        Else
                            If useoldvalueonovrwrite = False Then
                                imgdisp(g) = icon
                            End If
                        End If
                        If useoldvalueonovrwrite = False Then
                            errdisp(g) = browserdispfileonviewinbrowserfalse
                        End If
                        If errdisp(g) = "" Then
                            errdisp(g) = "usrnodisp.htm"
                        End If
                    Else
                        name(itemamt) = extensionname
                        view(itemamt) = viewinbrowser
                        edit(itemamt) = write
                        disp(itemamt) = disptxt
                        imgdisp(itemamt) = icon
                        If view(itemamt) = False Then
                            errdisp(itemamt) = browserdispfileonviewinbrowserfalse
                        End If
                        tagamt = tagamt + 1
                    End If

                    'writes new data to the file
                    Dim setn As New Xml.XmlWriterSettings()
                    setn.Indent = True
                    setn.IndentChars = " "
                    Using writer As Xml.XmlWriter = Xml.XmlWriter.Create(mdir)
                        writer.WriteComment("Please do not edit this file. It might affect the whole application of HTML Editor")
                        writer.WriteStartElement("tags")

                        writer.WriteStartElement("script")
                        writer.WriteElementString("version", "1")
                        writer.WriteElementString("tagamt", tagamt)
                        writer.WriteEndElement()

                        itemamt = 0
                        Do Until itemamt = tagamt
                            writer.WriteStartElement("tag")
                            writer.WriteElementString("name", name(itemamt))
                            writer.WriteElementString("view", view(itemamt))
                            writer.WriteElementString("edit", edit(itemamt))
                            writer.WriteElementString("disp", disp(itemamt))
                            writer.WriteElementString("imgdisp", imgdisp(itemamt))
                            If view(itemamt) = False Then
                                writer.WriteElementString("errdisp", errdisp(itemamt))
                            End If
                            writer.WriteEndElement()
                            itemamt = itemamt + 1
                        Loop
                        writer.WriteEndElement()
                        writer.Flush()
                    End Using
                End If
            Catch
                MsgBox("Error!", , "Error!")
            End Try
        End If
    End Sub
    Public Shared Function read(ByVal extensionname As String, Optional ByVal periodthere As Boolean = True)
        'period adding/subtracting
        If periodthere = True Then
            extensionname = extensionname.Remove(0, 1)
        End If


        'dim all variables
        Dim datareturn(5) As String
        Dim inum As New Single
        Dim mdir As String
        Dim tagamt As New Single
        Dim name(99999) As String
        Dim view(99999) As Boolean
        Dim edit(99999) As Boolean
        Dim disp(99999) As String
        Dim imgdisp(99999) As String
        Dim errdisp(99999) As String
        Dim isthere As Boolean = True
        mdir = Settings.mdirectory & "\views\utags.xml"
        'Checks if file exists
        If My.Computer.FileSystem.FileExists(mdir) = False Then
            MsgBox("The file " & mdir & " was not found. Please reload the program")
        Else
            Try

                'gets the contents of the file
                Dim sr As New System.IO.StreamReader(mdir)
                Dim xr As New System.Xml.XmlTextReader(sr)
                Dim doc As New System.Xml.XmlDocument
                doc.Load(xr)
                Dim xmlr As System.Xml.XmlNodeList = doc.SelectNodes("tags/script")
                Dim ver As Integer = xmlr.Item(0).FirstChild.InnerText
                If ver <> 1 Then
                    MsgBox("The versions of the file " & mdir & " do not comply with the reader. The file cannot be read")
                Else
                    tagamt = xmlr.Item(0).FirstChild.NextSibling.InnerText
                    xmlr = doc.SelectNodes("tags/tag")
                    Dim itemamt As Single = 0
                    Do Until tagamt = itemamt
                        name(itemamt) = xmlr.Item(itemamt).FirstChild.InnerText
                        view(itemamt) = xmlr.Item(itemamt).FirstChild.NextSibling.InnerText
                        edit(itemamt) = xmlr.Item(itemamt).FirstChild.NextSibling.NextSibling.InnerText
                        disp(itemamt) = xmlr.Item(itemamt).FirstChild.NextSibling.NextSibling.NextSibling.InnerText
                        imgdisp(itemamt) = xmlr.Item(itemamt).FirstChild.NextSibling.NextSibling.NextSibling.NextSibling.InnerText
                        If view(itemamt) = False Then
                            errdisp(itemamt) = xmlr.Item(itemamt).FirstChild.NextSibling.NextSibling.NextSibling.NextSibling.NextSibling.InnerText
                        End If
                        itemamt = itemamt + 1
                    Loop
                    sr.Close()
                    'finds the file
                    Dim found As Boolean = False
                    inum = 0
                    Do Until found = True Or name(inum) = ""
                        If extensionname = name(inum) Then
                            found = True
                        End If
                        inum = inum + 1
                    Loop
                    If found = False Then
                        isthere = False
                    End If
                    inum = inum - 1
                End If
            Catch
                MsgBox("Error", , "Error")
                isthere = False
            End Try
        End If
        If isthere = True Then
            datareturn(0) = "."
        End If
        If view(inum) = True Then
            datareturn(1) = "."
        End If
        If edit(inum) = True Then
            datareturn(2) = "."
        End If
        datareturn(3) = disp(inum)
        datareturn(4) = imgdisp(inum)
        datareturn(5) = errdisp(inum)
        If view(inum) = True Then
            datareturn(5) = ""
        End If

        Return datareturn
    End Function
End Class
