Public Class files

    Public Shared Function getextension(ByVal filename As String, Optional ByVal addperiod As Boolean = False, Optional ByVal returnerror As Boolean = False) As String
        Dim extension As String = ""

        If filename.Contains(".") = False Then
            If returnerror = True Then
                extension = "#getfilename_error"
            Else
                extension = ""
            End If
        Else
            filename.LastIndexOf(".")
            extension = filename.Substring(filename.LastIndexOf(".") + 1)
            If addperiod = True Then
                extension = "." + extension
            End If
        End If


        Return extension
    End Function
    Public Shared Function getfilename(ByVal filepath As String, Optional ByVal addextension As Boolean = True, Optional ByVal returnerror As Boolean = False) As String
        Dim name As String = ""
        If filepath.Contains("\") = False And filepath.Contains("/") = False Then
            If returnerror = True Then
                name = "#getfilename_error"
            Else
                name = ""
            End If
        Else
            If filepath.Contains("\") = True And filepath.Contains("/") = True Then
                
                If filepath.LastIndexOf("/") > filepath.LastIndexOf("\") Then
                    name = filepath.Substring(filepath.LastIndexOf("\") + 1)
                Else
                    name = filepath.Substring(filepath.LastIndexOf("/") + 1)

                End If
            Else

            If filepath.Contains("\") = True Then
                name = filepath.Substring(filepath.LastIndexOf("\") + 1)
            Else
                name = filepath.Substring(filepath.LastIndexOf("/") + 1)

                End If
            End If
            If addextension = False Then
                If name.Contains(".") = False Then
                    If returnerror = True Then
                        name = "#getfilename_error"
                    Else
                        name = ""
                    End If
                Else
                    name = name.Replace(name.Substring(name.LastIndexOf(".")), "")
                End If
            End If
        End If
        Return name
    End Function
    Public Shared Function getfolderpath(ByVal filepath As String, Optional ByVal addendslashmark As Boolean = False, Optional ByVal returnerror As Boolean = False) As String
        Dim folderpath As String = ""
        Dim subfilepath As String = ""
        Try




            If filepath.Contains("\") = False And filepath.Contains("/") = False Then
                If returnerror = True Then
                    folderpath = "#getfilepath_error"
                Else
                    folderpath = ""
                End If
            Else
                If filepath.Contains("\") = True And filepath.Contains("/") = True Then
                    If filepath.LastIndexOf("/") > filepath.LastIndexOf("\") Then
                        subfilepath = filepath.Substring(filepath.LastIndexOf("/"))
                        folderpath = filepath.Replace(subfilepath, "")
                        If addendslashmark = True Then
                            folderpath = folderpath + "/"
                        End If
                    Else
                        subfilepath = filepath.Substring(filepath.LastIndexOf("\"))
                        folderpath = filepath.Replace(subfilepath, "")
                        If addendslashmark = True Then
                            folderpath = folderpath + "\"
                        End If
                    End If
                Else
                    If filepath.Contains("\") = True Then
                        subfilepath = filepath.Substring(filepath.LastIndexOf("\"))
                        folderpath = filepath.Replace(subfilepath, "")
                        If addendslashmark = True Then
                            folderpath = folderpath + "\"
                        End If
                    Else
                        subfilepath = filepath.Substring(filepath.LastIndexOf("/"))
                        folderpath = filepath.Replace(subfilepath, "")
                        If addendslashmark = True Then
                            folderpath = folderpath + "/"
                        End If
                    End If
                End If
            End If
        Catch
            If returnerror = True Then
                folderpath = "#getfilepath_error"
            Else
                folderpath = ""
            End If
        End Try
        Return folderpath
    End Function
End Class
